#include <dos.h>

/*
** Enable or disable the system menu Close command for an application
*/
int win95_setclose(int enabled)
{
	_DX=(enabled)?1:0;
	_AX=0x168f;
	geninterrupt(0x2f);
	return _AX;
}

/*
** Once a Close command has been issued, no further keyboard input is
** available to the application until it calls this function
** to acknowledge the Close request
*/
int win95_ackclose(void)
{
	_DX=0x0200;
	_AX=0x168f;
	geninterrupt(0x2f);
	return _AX;
}

/*
** Cancels a close request which has already been acknowledged if the
** application determines that it will not exit at this time
*/
int win95_cancelclose(void)
{
	_DX=0x0300;
	_AX=0x168f;
	geninterrupt(0x2f);
	return _AX;
}

/*
** Determine whether the user has requested that the application be
** closed by selecting the system menu's Close option
**
** returns:
**	0000h Close command selected but not yet acknowledged
**	0001h Close command issued and acknowledged
**	168Fh Close command not selected -- application should continue
*/
int win95_queryclose(void)
{
	_DX=0x0100;
	_AX=0x168f;
	geninterrupt(0x2f);
	return _AX;
}

/*
** Copy as much of the application's wiidow title as possible to the
** given buffer, appending a terminating NUL to the buffer
*/
int win95_getapptitle(char *buf,int n)
{
	_CX=n;
	_DI=FP_OFF(buf);
	_ES=FP_SEG(buf);
	_AX=0x168E;
	_DX=0x0002;
	geninterrupt(0x2f);
	return !_AX;
}

/*
** Note: If ES:DI is 0000h:0000h or points at an empty string,
** the current title is removed
**
** This function can return a successful status even though
** the title was not changed, this is bug in Windows
*/
int win95_setapptitle(char *title)
{
	_DI=FP_OFF(title);
	_ES=FP_SEG(title);
	_AX=0x168E;
	_DX=0x0000;
	geninterrupt(0x2f);
	return !_AX;
}

/*
** Copy as much of the virtual machine title as possible to the
** given buffer, appending a terminating NUL to the buffer
*/
int win95_getvmtitle(char *buf,int n)
{
	_CX=n;
	_DI=FP_OFF(buf);
	_ES=FP_SEG(buf);
	_AX=0x168E;
	_DX=0x0003;
	geninterrupt(0x2f);
	return !_AX;
}

/*
** Notes: If ES:DI is 0000h:0000h or points at an empty string, the current
** title is removed. The VM title should only be changed on explicit
** instruction from the user
** 
** This function can return a successful status even though the
** title was not changed, this is a bug in Windows
*/
int win95_setvmtitle(char *title)
{
	_DI=FP_OFF(title);
	_ES=FP_SEG(title);
	_AX=0x168E;
	_DX=0x0001;
	geninterrupt(0x2f);
	return !_AX;
}
